import java.awt.*;

public class SimpleMap extends AbstractMap{
    private final Color barrierColor = Color.black;
    private final Color roadColor = Color.gray;
    @Override
    protected void DrawBarrierPart(Graphics g, int i, int j)
    {
        Graphics2D g2d = (Graphics2D) g;
        g2d.setPaint(barrierColor);
        g2d.fillRect((int)(i * _size_x), (int) (j * _size_y), (int)(i * (_size_x + 1)), (int)(j * (_size_y + 1)));
    }
    @Override
    protected void DrawRoadPart(Graphics g, int i, int j)
    {
        Graphics2D g2d = (Graphics2D) g;
        g2d.setPaint(roadColor);
        g2d.fillRect((int)(i * _size_x), (int) (j * _size_y), (int)(i * (_size_x + 1)), (int)(j * (_size_y + 1)));
    }
    @Override
    protected void GenerateMap()
    {
        _map = new int[100][100];
        _size_x = (float)_width / _map.length;
        _size_y = (float)_height / _map[0].length;
        int counter = 0;
        for (int i = 0; i < _map.length; ++i)
        {
            for (int j = 0; j < _map[0].length; ++j)
            {
                _map[i][j] = _water;
            }
        }
        while (counter < 20)
        {
            int x = _random.nextInt(0, 100);
            int y = _random.nextInt(0, 100);
            if (_map[x][y] == _water)
            {
                _map[x][y] = _barrier;
                counter++;
            }
        }
    }
}
